Summary: GNU C Compiler and F77 Compiler
Name: gcc
Version: 2.7.2.fu.1
Release: 1C
Copyright: GPL
Group: Development/Languages
Source0: ftp://prep.ai.mit.edu/pub/gnu/gcc-2.7.2.tar.gz
Source1: ftp://prep.ai.mit.edu/pub/gnu/g77-0.5.19.tar.gz
Source2: ftp://ftp.dl.ac.uk/pub/fx/libU77/g77-0.5.19-libu77-12.tar.gz
Patch0: sunsite.unc.edu:/pub/Linux/GCC/gcc-2.7.2-linux.diff.gz
Patch1: gcc-2.7.2-make.patch
Patch2: gcc-2.7.2-ppc.patch
Patch3: gcc-2.7.2-ppc_shared_libraries.patch
Patch4: gcc-2.7.2.objc.960906.diff
Patch5: gcc-2.7.2-ppc_varargs.patch
Patch6: gcc-2.7.2-ppc_mcount.patch
Patch7: g77-0.5.19-glibc.patch
Patch8: g77-0.5.19-ppc.patch
Patch9: g77-0.5.19u-ppc_shared.patch

%description
The GNU C compiler -- a full featured ANSI C compiler, with support
for K&R C as well. GCC provides many levels of source code error
checking tradionaly provided by other tools (such as lint), produces
debugging information, and can perform many different optimizations to
the resulting object code. This contains the back end for C++ and 
Objective C compilers as well.

%package c++
Summary: C++ support for gcc
Group: Development/Languages
Requires:  gcc = 2.7.2.fu.1

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.

%package objc
Summary: Objective C support for gcc
Group: Development/Languages
Requires:  gcc = 2.7.2.fu.1

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%package g77
Summary: Fortran 77 support for gcc
Group: Development/Languages
Requires:  gcc = 2.7.2.fu.1

%description g77
This package adds Fortran 77 support to the GNU C compiler.
It does include f2c.h and libf2c.a so that f2c/gcc-generated
object files will be compatible with g77.

%prep
%setup -T -c -a 0
%setup -T -D -a 1
%setup -T -D -a 2

cd g77-0.5.19
patch -p1 < g77-0.5.19-u77.diff
cd ..

mv g77-0.5.19 gcc-2.7.2
cd gcc-2.7.2
%patch0 -p2
%patch1 -p1 -b .rh

%ifarch ppc
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
cd g77-0.5.19
%patch7 -p1
%patch8 -p1
%patch9 -p1
cd ..
%endif

mv g77-0.5.19/f .
patch -p1 <f/gbe/2.7.2.diff
echo 'char *version_string = "2.7.2.1-ppclinux";'>version.c
touch f77-install-ok
touch f2c-install-ok

cp NEWS PROBLEMS ..

%build

cd gcc-2.7.2

%ifarch i386
./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ --enable-libu77 i486-linux
%endif
%ifarch axp
./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ --enable-libu77 alpha-linux
%endif
%ifarch ppc
CFLAGS="-O2" ./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ --with-gnu-as --with-gnu-ld --enable-libu77 ppc-linux
%endif

# Someday, when I have hours to burn...
%ifnarch ppc
make LANGUAGES=c
make stage1
make CC="stage1/xgcc -Bstage1/" CFLAGS="-O" LDFLAGS="-s"
make stage2
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"
%else
make LANGUAGES="c c++ objective-c proto objc-runtime f77"
%endif

# Wait until this works...
%ifnarch ppc
# For Objective C only
make objc-runtime CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"
%endif

%install

cd gcc-2.7.2

rm -f /lib/cpp
rm -f /usr/info/gcc.info* /usr/info/cpp.info*
%ifnarch ppc
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s" install
%else
make LANGUAGES="c c++ objective-c proto f77" install
ln -sf /usr/include/g++ /usr/lib/g++-include
%endif

# Wait until this works...
# For Objective C only
make install-libobjc CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"

gzip -n -9f /usr/info/gcc.info* /usr/info/cpp.info* /usr/info/g77.info*

rm -f /usr/bin/cc
ln -sf gcc /usr/bin/cc
ln -sf cccp.1 /usr/man/man1/cpp.1

%ifarch i386
ln -sf ../usr/lib/gcc-lib/i486-linux/2.7.2/cpp /lib/cpp
cp libf2c.so /usr/lib/gcc-lib/i486-linux/2.7.2/libf2c.so
chmod a+x /usr/lib/gcc-lib/i486-linux/2.7.2/libf2c.so
ln -sf gcc-lib/i486-linux/2.7.2/libf2c.so /usr/lib/libf2c.so
%endif
%ifarch axp
ln -sf ../usr/lib/gcc-lib/alpha-linux/2.7.2/cpp /lib/cpp
cp libf2c.so /usr/lib/gcc-lib/alpha-linux/2.7.2/libf2c.so
chmod a+x /usr/lib/gcc-lib/alpha-linux/2.7.2/libf2c.so
ln -sf gcc-lib/alpha-linux/2.7.2/libf2c.so /usr/lib/libf2c.so
%endif
%ifarch ppc
ln -sf ../usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cpp /lib/cpp
cp libf2c.so /usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/libf2c.so
chmod a+x /usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/libf2c.so
ln -sf gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/libf2c.so /usr/lib/libf2c.so
%endif

%post g77
/sbin/ldconfig

%postun g77
/sbin/ldconfig

%files
%doc NEWS PROBLEMS

%dir /usr/lib/gcc-lib
%ifarch i386
%dir /usr/lib/gcc-lib/i486-linux/2.7.2
%dir /usr/lib/gcc-lib/i486-linux/2.7.2/include
%endif
%ifarch axp
%dir /usr/lib/gcc-lib/alpha-linux/2.7.2
%dir /usr/lib/gcc-lib/alpha-linux/2.7.2/include
%endif
%ifarch ppc
%dir /usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux
%dir /usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include
%endif

%ifarch i386
/usr/bin/i486-linux-gcc
%endif 
%ifarch axp
/usr/bin/alpha-linux-gcc
%endif
%ifarch ppc
/usr/bin/powerpc-unknown-linux-gcc
%endif

/usr/bin/gcc
/usr/bin/cc
/usr/bin/protoize
/usr/bin/unprotoize

/lib/cpp

/usr/man/man1/cpp.1
/usr/man/man1/cccp.1
/usr/man/man1/gcc.1
/usr/man/man1/g77.1

/usr/info/cpp.info*
/usr/info/gcc.info*
/usr/info/g77.info*

%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/SYSCALLS.c.X
/usr/lib/gcc-lib/i486-linux/2.7.2/cc1
/usr/lib/gcc-lib/i486-linux/2.7.2/cpp
/usr/lib/gcc-lib/i486-linux/2.7.2/libgcc.a
/usr/lib/gcc-lib/i486-linux/2.7.2/specs

/usr/lib/gcc-lib/i486-linux/2.7.2/include/README
/usr/lib/gcc-lib/i486-linux/2.7.2/include/float.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/iso646.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/limits.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/proto.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/stdarg.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/stddef.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/syslimits.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-alpha.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-clipper.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-h8300.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-i860.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-i960.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-m88k.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-mips.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-pa.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-pyr.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-sparc.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/va-spur.h
/usr/lib/gcc-lib/i486-linux/2.7.2/include/varargs.h
%endif

%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/SYSCALLS.c.X
/usr/lib/gcc-lib/alpha-linux/2.7.2/cc1
/usr/lib/gcc-lib/alpha-linux/2.7.2/cpp
/usr/lib/gcc-lib/alpha-linux/2.7.2/libgcc.a
/usr/lib/gcc-lib/alpha-linux/2.7.2/specs

/usr/lib/gcc-lib/alpha-linux/2.7.2/include/README
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/float.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/iso646.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/limits.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/proto.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/stdarg.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/stddef.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/syslimits.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-alpha.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-clipper.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-h8300.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-i860.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-i960.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-m88k.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-mips.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-pa.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-pyr.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-sparc.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/va-spur.h
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/varargs.h
%endif

%ifarch ppc
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/syslimits.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/stdarg.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/stddef.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/varargs.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-alpha.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-h8300.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-i860.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-i960.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-mips.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-m88k.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-pa.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-pyr.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-sparc.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-clipper.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-spur.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/iso646.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/va-ppc.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/proto.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/ppc-asm.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/limits.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/README
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/float.h
#/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/errno.h
#/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/curses.h
#/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/unistd.h
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/fixed
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cc1
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/specs
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cpp
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/libgcc.a
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/nof
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/pic
%endif

%files c++
/usr/man/man1/g++.1
/usr/bin/g++
/usr/bin/c++

%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/cc1plus
%endif
%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/cc1plus
%endif
%ifarch ppc
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cc1plus
/usr/lib/g++-include
%endif

# Wait until this works...
#%ifnarch ppc
%files objc
%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/cc1obj
/usr/lib/gcc-lib/i486-linux/2.7.2/libobjc.a
/usr/lib/gcc-lib/i486-linux/2.7.2/include/objc
%endif
%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/cc1obj
/usr/lib/gcc-lib/alpha-linux/2.7.2/libobjc.a
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/objc
%endif
%ifarch ppc
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/cc1obj
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/libobjc.a
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/objc
%endif
#%endif

%files g77
/usr/bin/g77
/usr/bin/f77
/usr/lib/libf2c.so
%ifarch i386
/usr/lib/gcc-lib/i486-linux/2.7.2/f771
/usr/lib/gcc-lib/i486-linux/2.7.2/libf2c.a
/usr/lib/gcc-lib/i486-linux/2.7.2/libf2c.so
/usr/lib/gcc-lib/i486-linux/2.7.2/include/f2c.h
%endif
%ifarch axp
/usr/lib/gcc-lib/alpha-linux/2.7.2/f771
/usr/lib/gcc-lib/alpha-linux/2.7.2/libf2c.a
/usr/lib/gcc-lib/alpha-linux/2.7.2/libf2c.so
/usr/lib/gcc-lib/alpha-linux/2.7.2/include/f2c.h
%endif
%ifarch ppc
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/f771
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/libf2c.a
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/libf2c.so
/usr/lib/gcc-lib/powerpc-unknown-linux/2.7.2.1-ppclinux/include/f2c.h
%endif
#%endif
